#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/List.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleBG.h>
#include <X11/cursorfont.h>
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "global.h"
#include "messages.h"
#include "nrutil.h"

/* Structure for ANOVA */
typedef struct {
  int  ssq_type;  // type I, II, III for sum of squares in ANOVAII;
  int  ways;
  int  nlist;
  int  *list;
  int  indep_group_var;
} anova_struct;


void anova_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  static anova_struct  *anova;
  static Widget        anova1r_dialog, form, frame, anova1r_list_w[2];
  static Widget        anova1i_dialog, rc, anova1i_list_w[2];
  static Widget        anova2ir_dialog, anova2i_list_w[2], anova2r_list_w[2];
  static Widget        anova2ii_dialog, anova2ii_list_w[4];
  static Widget        radio_box, toggle[3];
  int           item, i, j, cols, dep_count;
  short         is_sort;
  Arg           args[5];
  Widget        toplevel;
  String        *clabels;
  XmStringTable dep_list;

  extern void showmess(Widget widget, char *title, char *text);
  extern void cancel_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova1_rep_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova1_rep_list0_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova1_rep_list1_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void group_anova1i_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova1i_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova2ir_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void anova2ii_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void ssqtoggle_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  item=(int) client_data;
  if (!anova) {
    anova=new anova_struct;
    anova->nlist=0;
    anova->list=new int[1];
    anova->indep_group_var=0;
    anova->ways=1;
  }
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);

  switch(item) {
  case 0:      // ANOVA-one-way, repeated;
    /* create dialog */
    anova->ways=1;
    if (!anova1r_dialog) {
      i=0;
      XtSetArg(args[i], XmNdialogTitle,
	       XmStringCreateLocalized("one-way-ANOVA, repeated measures"));
      i++;
      XtSetArg(args[i], XmNmessageString,
	       XmStringCreateLocalized("select repeated variables:"));
      i++;
      XtSetArg(args[i], XmNautoUnmanage, False);
      i++;
      anova1r_dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(anova1r_dialog, XmDIALOG_HELP_BUTTON));
      XtAddCallback(anova1r_dialog, XmNokCallback, anova1_rep_ok_cb, (XtPointer)anova);
      XtAddCallback(anova1r_dialog, XmNcancelCallback, cancel_cb, NULL);
      form=XtVaCreateWidget("form", xmFormWidgetClass, anova1r_dialog,
			    XmNwidth, 250,
			    XmNheight, 150,
			    NULL);
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, form,
				    XmNshadowType, XmSHADOW_OUT,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNbottomAttachment, XmATTACH_FORM,
				    NULL);
      XtVaCreateManagedWidget("select from", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      i=0;
      XtSetArg(args[i], XmNselectionPolicy, XmSINGLE_SELECT); i++;
      XtSetArg(args[i], XmNuserData, anova); i++;
      anova1r_list_w[0]=XmCreateScrolledList(frame, "alllist", args, i);
      XtAddCallback(anova1r_list_w[0], XmNsingleSelectionCallback, anova1_rep_list0_cb, anova1r_list_w);
      XtManageChild(anova1r_list_w[0]);
      /* create list widget for repeated variables */
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, form,
				    XmNshadowType, XmSHADOW_OUT,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNrightAttachment, XmATTACH_FORM,
				    XmNleftAttachment, XmATTACH_WIDGET,
				    XmNleftWidget, XtParent(anova1r_list_w[0]),
				    XmNbottomAttachment, XmATTACH_FORM,
				    NULL);
      XtVaCreateManagedWidget("repeated variables", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      i=0;
      XtSetArg(args[i], XmNselectionPolicy, XmSINGLE_SELECT); i++;
      XtSetArg(args[i], XmNuserData, anova); i++;
      anova1r_list_w[1]=XmCreateScrolledList(frame, "list2", args, i);
      XtAddCallback(anova1r_list_w[1], XmNsingleSelectionCallback, anova1_rep_list1_cb, anova1r_list_w);
      XtManageChild(anova1r_list_w[1]);
      XtManageChild(form);
    }
    /* create list of all that are not sort */
    XmListDeleteAllItems(anova1r_list_w[0]);
    if (cols-sort.nsort>0) {
      dep_list=(XmStringTable) XtMalloc ((cols-sort.nsort) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) {
	  if (i==sort.sort[j]) is_sort=1;
	}
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	  dep_count++;
	}
      }
      XtVaSetValues(anova1r_list_w[0],
		    XmNitemCount, (cols-sort.nsort),
		    XmNitems, dep_list,
		    NULL);
    }
    /* prepare list of repeated variables */
    XmListDeleteAllItems(anova1r_list_w[1]);
    anova->nlist=0;
    /* manage everything */
    XtManageChild(anova1r_dialog);
    XtPopup(XtParent(anova1r_dialog), XtGrabNone);
    break;
  case 1:      // ANOVA-one-way, independent;
    anova->ways=1;
    if (sort.ndep>0) {
      /* create dialog */
      if (!anova1i_dialog) {
	i=0;
	XtSetArg(args[i], XmNdialogTitle,
		 XmStringCreateLocalized("one-way-ANOVA, independent measures"));
	i++;
	XtSetArg(args[i], XmNmessageString,
		 XmStringCreateLtoR("1. Select one variable that defines the groups.\n2. Select levels for comparison.",XmFONTLIST_DEFAULT_TAG));
	i++;
	XtSetArg(args[i], XmNautoUnmanage, False); i++;
	XtSetArg(args[i], XmNheight, 350); i++;
	XtSetArg(args[i], XmNuserData, anova); i++;
	anova1i_dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
	XtUnmanageChild(XmMessageBoxGetChild(anova1i_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback(anova1i_dialog, XmNokCallback, anova1i_ok_cb, anova1i_list_w);
	XtAddCallback(anova1i_dialog, XmNcancelCallback, cancel_cb, NULL);
	rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, anova1i_dialog,
			    XmNorientation, XmHORIZONTAL,
			    NULL);
	/* create list widget for selection of group variable */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("group variable", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova1i_list_w[0]=XmCreateScrolledList(frame, "deplist", NULL, 0);
	XtVaSetValues(anova1i_list_w[0],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmSINGLE_SELECT,
		      XmNuserData, anova,
		      NULL);
	XtAddCallback(anova1i_list_w[0], XmNsingleSelectionCallback, group_anova1i_cb, anova1i_list_w);
	XtManageChild(anova1i_list_w[0]);
	/* create list of levels for the group variable */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("levels of group variable", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova1i_list_w[1]=XmCreateScrolledList(frame,"sortlist", NULL, 0);
	XtVaSetValues(anova1i_list_w[1],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmMULTIPLE_SELECT,
		      NULL);
	XtManageChild(anova1i_list_w[1]);
	XtManageChild(rc);
      }
      /* create list for selection of group variable  */
      if (cols-sort.nsort-sort.ndep>0) {
	dep_list=(XmStringTable)XtMalloc((cols-sort.nsort-sort.ndep)*sizeof(XmString));
	dep_count=0;
	for (i=0; i<cols; i++) {
	  is_sort=0;
	  for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	  for (j=0; j<sort.ndep; j++)  if (i==sort.dep[j]) is_sort=1;
	  if (!is_sort) {
	    dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	    dep_count++;
	  }
	}
	XtVaSetValues(anova1i_list_w[0],
		      XmNitemCount, (cols-sort.nsort-sort.ndep),
		      XmNitems, dep_list,
		      NULL);
      }
      XtVaGetValues(anova1i_list_w[0], XmNitemCount, &dep_count, NULL);
      if (dep_count>0) XmListSelectPos(anova1i_list_w[0], 1, True);
      XtManageChild(anova1i_dialog);
      XtPopup(XtParent(anova1i_dialog), XtGrabNone);

      if (cols-sort.nsort-sort.ndep > 0) {
	for (i=0; i<(cols-sort.nsort-sort.ndep); i++) XmStringFree(dep_list[i]);
	XtFree((char *)dep_list);
      }
    }
    else {
      showmess(StatData, ANOVA1I_NOVAR_T, ANOVA1I_NOVAR_M);
    }
    break;
  case 2:      // ANOVA-two-way, repeated-repeated;
    anova->ways=2;
    showmess(StatData, NOT_IMPLEMENTED_T, NOT_IMPLEMENTED_M);
    break;
  case 3:      // ANOVA-two-way, independent-repeated;
    anova->ways=2;
    /* create dialog */
    if (!anova2ir_dialog) {
      i=0;
      XtSetArg(args[i], XmNdialogTitle,
	       XmStringCreateLocalized("two-way-ANOVA, independent-repeated measures"));
      i++;
      XtSetArg(args[i], XmNmessageString,
	       XmStringCreateLtoR("1. Select one variable that defines the independent levels.\n2. Select independent levels for comparison.\n3. Select repeated variables.",XmFONTLIST_DEFAULT_TAG));
      i++;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      XtSetArg(args[i], XmNheight, 350); i++;
      XtSetArg(args[i], XmNuserData, anova); i++;
      anova2ir_dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(anova2ir_dialog, XmDIALOG_HELP_BUTTON));
      XtAddCallback(anova2ir_dialog, XmNokCallback, anova2ir_ok_cb, anova2i_list_w);
      XtAddCallback(anova2ir_dialog, XmNcancelCallback, cancel_cb, NULL);
      rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, anova2ir_dialog,
			  XmNorientation, XmHORIZONTAL,
			  NULL);
      /* create list widget for selection of independent group variable */
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				    XmNshadowType, XmSHADOW_OUT,
				    NULL);
      XtVaCreateManagedWidget("independent variable", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      anova2i_list_w[0]=XmCreateScrolledList(frame, "deplist", NULL, 0);
      XtVaSetValues(anova2i_list_w[0],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNuserData, anova,
		    NULL);
      XtAddCallback(anova2i_list_w[0], XmNsingleSelectionCallback, group_anova1i_cb, anova2i_list_w);
      XtManageChild(anova2i_list_w[0]);
      /* create list of levels for the independent variable */
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				    XmNshadowType, XmSHADOW_OUT,
				    NULL);
      XtVaCreateManagedWidget("independent levels", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      anova2i_list_w[1]=XmCreateScrolledList(frame,"sortlist", NULL, 0);
      XtVaSetValues(anova2i_list_w[1],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmMULTIPLE_SELECT,
		    NULL);
      XtManageChild(anova2i_list_w[1]);

      /* repeated variable list widgets */
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				    XmNshadowType, XmSHADOW_OUT,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNbottomAttachment, XmATTACH_FORM,
				    NULL);
      XtVaCreateManagedWidget("repeated variables", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      i=0;
      XtSetArg(args[i], XmNselectionPolicy, XmSINGLE_SELECT); i++;
      XtSetArg(args[i], XmNuserData, anova); i++;
      anova2r_list_w[0]=XmCreateScrolledList(frame, "alllist", args, i);
      XtAddCallback(anova2r_list_w[0], XmNsingleSelectionCallback, anova1_rep_list0_cb, anova2r_list_w);
      XtManageChild(anova2r_list_w[0]);

      /* create list widget for repeated variables */
      frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				    XmNshadowType, XmSHADOW_OUT,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNrightAttachment, XmATTACH_FORM,
				    XmNleftAttachment, XmATTACH_WIDGET,
				    XmNleftWidget, XtParent(anova2r_list_w[0]),
				    XmNbottomAttachment, XmATTACH_FORM,
				    NULL);
      XtVaCreateManagedWidget("repeated levels", xmLabelGadgetClass, frame,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      i=0;
      XtSetArg(args[i], XmNselectionPolicy, XmSINGLE_SELECT); i++;
      XtSetArg(args[i], XmNuserData, anova); i++;
      anova2r_list_w[1]=XmCreateScrolledList(frame, "list2", args, i);
      XtAddCallback(anova2r_list_w[1], XmNsingleSelectionCallback, anova1_rep_list1_cb, anova2r_list_w);
      XtManageChild(anova2r_list_w[1]);
      XtManageChild(rc);
    } /* endif */
    /* create list for selection of independent variables (based on sort) */
    if (cols-sort.nsort>0) {
      dep_list=(XmStringTable)XtMalloc((cols-sort.nsort) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	  dep_count++;
	}
      }
      XtVaSetValues(anova2i_list_w[0],
		    XmNitemCount, (cols-sort.nsort),
		    XmNitems, dep_list,
		    NULL);
    }
    XtVaGetValues(anova2i_list_w[0], XmNitemCount, &dep_count, NULL);
    if (dep_count>0) XmListSelectPos(anova2i_list_w[0], 1, True);
      
    if (cols-sort.nsort > 0) {
      for (i=0; i<(cols-sort.nsort); i++) XmStringFree(dep_list[i]);
      XtFree((char *)dep_list);
    }

    /* create list of repeated variables that are not sort */
    XmListDeleteAllItems(anova2r_list_w[0]);
    if (cols-sort.nsort>0) {
      dep_list=(XmStringTable) XtMalloc ((cols-sort.nsort) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) {
	  if (i==sort.sort[j]) is_sort=1;
	}
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	  dep_count++;
	}
      }
      XtVaSetValues(anova2r_list_w[0],
		    XmNitemCount, (cols-sort.nsort),
		    XmNitems, dep_list,
		    NULL);
    }
    
    /* prepare list of repeated variables */
    XmListDeleteAllItems(anova2r_list_w[1]);
    anova->nlist=0;
    /* manage everything */
    XtManageChild(anova2ir_dialog);
    XtPopup(XtParent(anova2ir_dialog), XtGrabNone);
    break;
  case 4:      // ANOVA-two-way, independent-independent;
    anova->ways=2;
    anova->ssq_type=3; // use type III HTI as default;
    if (sort.ndep>0) {
      /* create dialog */
      if (!anova2ii_dialog) {
	i=0;
	XtSetArg(args[i], XmNdialogTitle,
		 XmStringCreateLocalized("two-way-ANOVA, independent-independent measures"));
	i++;
	XtSetArg(args[i], XmNmessageString,
		 XmStringCreateLtoR("1. Select the variables that define the independent levels.\n2. Select independent levels for comparison.\n3. Select a method for calculation of sums of squares",XmFONTLIST_DEFAULT_TAG));
	i++;
	XtSetArg(args[i], XmNautoUnmanage, False); i++;
	//XtSetArg(args[i], XmNheight, 350); i++;
	XtSetArg(args[i], XmNuserData, anova); i++;
	anova2ii_dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
	XtUnmanageChild(XmMessageBoxGetChild(anova2ii_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback(anova2ii_dialog, XmNokCallback, anova2ii_ok_cb, anova2ii_list_w);
	XtAddCallback(anova2ii_dialog, XmNcancelCallback, cancel_cb, NULL);
	rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, anova2ii_dialog,
			    XmNorientation, XmHORIZONTAL,
			    XmNpacking, XmPACK_COLUMN,
			    XmNnumColumns, 3,
			    NULL);
	/* create list widget for selection of independent group variable 1 */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("independent variable 1", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova2ii_list_w[0]=XmCreateScrolledList(frame, "deplist", NULL, 0);
	XtVaSetValues(anova2ii_list_w[0],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmSINGLE_SELECT,
		      XmNuserData, anova,
		      NULL);
	XtAddCallback(anova2ii_list_w[0], XmNsingleSelectionCallback, group_anova1i_cb, anova2ii_list_w);
	XtManageChild(anova2ii_list_w[0]);
	/* create list of levels for the independent variable 1 */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("independent levels 1", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova2ii_list_w[1]=XmCreateScrolledList(frame,"sortlist", NULL, 0);
	XtVaSetValues(anova2ii_list_w[1],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmMULTIPLE_SELECT,
		      NULL);
	XtManageChild(anova2ii_list_w[1]);
	
	/* now comes the second independent variable */
	/* create list widget for selection of independent group variable 2 */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("independent variable 2", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova2ii_list_w[2]=XmCreateScrolledList(frame, "deplist", NULL, 0);
	XtVaSetValues(anova2ii_list_w[2],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmSINGLE_SELECT,
		      XmNuserData, anova,
		      NULL);
	XtAddCallback(anova2ii_list_w[2], XmNsingleSelectionCallback, group_anova1i_cb, (anova2ii_list_w+2));
	XtManageChild(anova2ii_list_w[2]);
	/* create list of levels for the independent variable 2 */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("independent levels 2", xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);
	anova2ii_list_w[3]=XmCreateScrolledList(frame,"sortlist", NULL, 0);
	XtVaSetValues(anova2ii_list_w[3],
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      XmNselectionPolicy, XmMULTIPLE_SELECT,
		      NULL);
	XtManageChild(anova2ii_list_w[3]);
	/* create radio buttons for type of sum of squares */
	frame=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				      XmNshadowType, XmSHADOW_OUT,
				      NULL);
	XtVaCreateManagedWidget("Type of sum of squares for unbalanced designs",
				xmLabelGadgetClass, frame,
				XmNchildType, XmFRAME_TITLE_CHILD,
				XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
				XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
				NULL);

	radio_box=XmCreateRadioBox(frame, "radio_box", NULL, 0);
	XtVaSetValues(radio_box,
		      XmNchildType, XmFRAME_WORKAREA_CHILD,
		      NULL);
	toggle[0]=XtVaCreateManagedWidget("Type I (sequential)",
					  xmToggleButtonGadgetClass, radio_box,
					  NULL);
	toggle[1]=XtVaCreateManagedWidget("Type II (HTO)",
					  xmToggleButtonGadgetClass, radio_box,
					  NULL);
	toggle[2]=XtVaCreateManagedWidget("Type III (HTI)",
					  xmToggleButtonGadgetClass, radio_box,
					  NULL);
	XtVaSetValues(toggle[anova->ssq_type-1], XmNset, True, NULL);
	for (i=1; i<4; i++) {
	  XtAddCallback(toggle[i-1], XmNvalueChangedCallback, ssqtoggle_cb, (XtPointer) i);
	  XtVaSetValues(toggle[i-1], XmNuserData, anova, NULL);
	}
	XtManageChild(radio_box);
	XtManageChild(rc);
      }
      /* create list for selection of independent variables (based on sort) */
      if (cols-sort.nsort-sort.ndep>0) {
	dep_list=(XmStringTable)XtMalloc((cols-sort.nsort-sort.ndep) * sizeof(XmString));
	dep_count=0;
	for (i=0; i<cols; i++) {
	  is_sort=0;
	  for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	  for (j=0; j<sort.ndep; j++)  if (i==sort.dep[j]) is_sort=1;
	  if (!is_sort) {
	    dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	    dep_count++;
	  }
	}
	XtVaSetValues(anova2ii_list_w[0],
		      XmNitemCount, (cols-sort.nsort-sort.ndep),
		      XmNitems, dep_list,
		      NULL);
	XtVaSetValues(anova2ii_list_w[2],
		      XmNitemCount, (cols-sort.nsort-sort.ndep),
		      XmNitems, dep_list,
		      NULL);
      }
      XtVaGetValues(anova2ii_list_w[0], XmNitemCount, &dep_count, NULL);
      if (dep_count>0) XmListSelectPos(anova2ii_list_w[0], 1, True);
      XtVaGetValues(anova2ii_list_w[2], XmNitemCount, &dep_count, NULL);
      if (dep_count>1) XmListSelectPos(anova2ii_list_w[2], 2, True);
      else if (dep_count>0) XmListSelectPos(anova2ii_list_w[2], 1, True);
      
      if (cols-sort.nsort-sort.ndep > 0) {
	for (i=0; i<(cols-sort.nsort-sort.ndep); i++) XmStringFree(dep_list[i]);
	XtFree((char *)dep_list);
      }
      /* manage everything */
      XtManageChild(anova2ii_dialog);
      XtPopup(XtParent(anova2ii_dialog), XtGrabNone);
    }
    else {  // ndep <= 0;
      showmess(StatData, ANOVA2II_NOVAR_T, ANOVA1I_NOVAR_M);
    }
    break;
  }
}


/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void ssqtoggle_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  anova_struct   *anova;
  int            t;

  XtVaGetValues(widget, XmNuserData, &anova, NULL);

  t=(int) client_data;
  switch (t) {
  case 1:
    anova->ssq_type=1;
    break;
  case 2:
    anova->ssq_type=2;
    break;
  case 3:
    anova->ssq_type=3;
    break;
  }
}


void anova1_rep_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Cursor         uhr, pfeil;
  anova_struct   *anova;
  int            i, ii, j, jj, k, rows, ndata, startgroup, ncombi, ncombi2;
  short          is_invalid, rc;
  char           *out_buf, *temp, *pcells, signchar[2], nkchar[2];;
  String         *clabels, **cells;
  float          **data, xq, xi, sst, ssb, sse, mst, msb,  mse, fw, fb, pw, pb;
  float          *xqi, *s2i;
  int            *sortave, *nksig;
  float          f, t, df, **p_posthoc;

  extern void showmess(Widget widget, char *title, char *text);
  extern void resedit(char *text, char *title);
  extern void add_line(char *text, int n);
  extern void avevar(float data[], unsigned long n, float *ave, float *var);
  extern float betai(float a, float b, float x);
  extern double prtrng(double q, double v, double r, short *ifault);

  anova=(anova_struct *) client_data;
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);

  if (anova->nlist >=2) {
    /* set cursor */
    uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
    pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
    XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
    XFlush(XtDisplay(widget));
    /* Allocate memory */
    out_buf=new char [OUTBUFLEN];
    temp   =new char [256];
    data   =new float* [anova->nlist];
    xqi    =new float [anova->nlist];
    s2i    =new float [anova->nlist];
    sortave=new int [anova->nlist];
    nksig  =new int [anova->nlist*(anova->nlist-1)/2];
    p_posthoc = new float* [4]; // 0: scheffe, 1: tukey, 2: n-keul, 3: fisher;
    for (i=0; i<4; i++) p_posthoc[i]=new float [anova->nlist*(anova->nlist-1)/2];
    /* Headline for all */
    strcpy(out_buf, "ANOVA (one-way) for repeated measures \n\n");
    /* loop through sort variables */
    if (sort.ngroup==1) sort.group[0]=rows;
    startgroup=0;
    for (k=0; k<sort.ngroup; k++) {
      /* first allocate data pointer of pointer */
      for (i=0; i<anova->nlist; i++) data[i]=new float[sort.group[k]];
      /* get data in array */
      ndata=0;
      for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	is_invalid=0;
	for (i=0; i<anova->nlist; i++) {
	  data[i][ndata]=strtod(cells[j][anova->list[i]], &pcells);
	  // is it numeric ? ;
	  if (data[i][ndata]==0 && !strcmp(pcells,cells[j][anova->list[i]])) is_invalid=1;
	}
	if (!is_invalid) ndata++;
      }
      // calculate ANOVA;
      if (ndata>=2) {
	/* Headline for sort group*/
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 75);
	/* start calculation of ANOVA */
	// calculate overall mean xq;
	xq=0.0;
	for (i=0; i<anova->nlist; i++) {
	  avevar(data[i]-1, ndata, &xqi[i], &s2i[i]);
	  xq+=xqi[i];
	}
	xq/=(float)anova->nlist;
	// calculate SST;
	sst=0.0;
	for (i=0; i<anova->nlist; i++) sst+=((float)ndata*(xqi[i]-xq)*(xqi[i]-xq));
	// calculate SSB;
	ssb=0.0;
	for (i=0; i<ndata; i++) {
	  xi=0.0;
	  for (j=0; j<anova->nlist; j++) xi+=data[j][i];
	  xi/=(float)anova->nlist;
	  ssb+=((float)anova->nlist*(xi-xq)*(xi-xq));
	}
	// calculate SSE;
	sse=0.0;
	for (i=0; i<anova->nlist; i++)
	  for (j=0; j<ndata; j++)
	    sse+=((data[i][j]-xq)*(data[i][j]-xq));
	sse=sse-sst-ssb;
	// calculat MST, MSB, MSE, F, and p;
	mst=sst/(anova->nlist-1);
	msb=ssb/(ndata-1);
	mse=sse/(anova->nlist*ndata - ndata - anova->nlist +1);
	fw=mst/mse;
	pw=betai((float)(anova->nlist*ndata - ndata - anova->nlist +1)/2.0,
		 (float)(anova->nlist-1)/2.0,
		 (float)(anova->nlist*ndata - ndata - anova->nlist +1)/
		 ((float)(anova->nlist*ndata - ndata - anova->nlist +1)+(float)(anova->nlist-1)*fw));
	fb=msb/mse;
	pb=betai((float)(anova->nlist*ndata - ndata - anova->nlist +1)/2.0,
		 (float)(ndata-1)/2.0,
		 (float)(anova->nlist*ndata - ndata - anova->nlist +1)/
		 ((float)(anova->nlist*ndata - ndata - anova->nlist +1)+(float)(ndata-1)*fb));
	// output on out_buf;
	sprintf(temp, "%10s %4s %14s %14s %14s %14s\n",
		"Source", "df", "sum of squares", "mean squares", "F", "p");
	strcat(out_buf, temp);
	sprintf(temp, "%10s %4d %14.4f %14.4f %14.4f %14.4f \n",
		"within", anova->nlist-1, sst, mst, fw, pw);
	strcat(out_buf, temp);
	sprintf(temp, "%10s %4d %14.4f %14.4f %14.4f %14.4f \n",
		"between", ndata-1, ssb, msb, fb, pb);
	strcat(out_buf, temp);
	sprintf(temp, "%10s %4d %14.4f %14.4f \n",
		"error", (anova->nlist*ndata-anova->nlist-ndata+1), sse, mse);
	strcat(out_buf, temp);
	sprintf(temp, "%10s %4d %14.4f \n",
		"total", (anova->nlist*ndata-1), sse+sst+ssb);
	strcat(out_buf, temp);
	/* calculate post-hoc tests */
	/* get sort order by average */
	for (i=0; i<anova->nlist; i++) {
	  sortave[i]=1;
	  for (j=0; j<anova->nlist; j++) 
	    if (xqi[j]>xqi[i]) sortave[i]++;
	}
	/* set all combis for Newman-Keuls on significant */
	for (i=0; i<(anova->nlist*(anova->nlist-1)/2); i++) nksig[i]=1;
	/* start calculation for all comibs */
	ncombi=0;
	df=(float)(anova->nlist*ndata-anova->nlist-ndata+1.0);
	for (i=0; i<anova->nlist-1; i++) 
	  for (j=i+1; j<anova->nlist; j++) {
	    /* scheffe */
	    f=(xqi[i]-xqi[j])*(xqi[i]-xqi[j])/(2.0*mse*(anova->nlist-1)/ndata);
	    p_posthoc[0][ncombi]=betai(df/2.0,
				       (float)(anova->nlist-1.0)/2.0,
				       df/(df+((float)(anova->nlist-1)*f)));
	    /* Tukey's HSD test */
	    t=(xqi[i]-xqi[j])/sqrt(mse/(float)ndata);
	    p_posthoc[1][ncombi]=1.0-prtrng(fabs(t), df, anova->nlist, &rc);
	    /* Newman Keuls test */
	    p_posthoc[2][ncombi]=1.0-prtrng(fabs(t), df, 
					    abs(sortave[i]-sortave[j])+1, &rc);
	    if (p_posthoc[2][ncombi]>0.05) {
	      ncombi2=0;
	      for (ii=0; ii<anova->nlist-1; ii++) 
		for (jj=ii+1; jj<anova->nlist; jj++) {
		  if (sortave[i]<sortave[j]) {
		    if (sortave[ii]<sortave[jj]) {
		      if (((sortave[ii]>sortave[i]) && (sortave[jj]<=sortave[j])) ||
			  ((sortave[ii]>=sortave[i]) && (sortave[jj]<sortave[j]))) nksig[ncombi2]=0;
		    }
		    else {
		      if (((sortave[jj]>sortave[i]) && (sortave[ii]<=sortave[j])) ||
			  ((sortave[jj]>=sortave[i]) && (sortave[ii]<sortave[j]))) nksig[ncombi2]=0;
		    }
		  }
		  else {
		    if (sortave[ii]<sortave[jj]) {
		      if (((sortave[ii]>sortave[j]) && (sortave[jj]<=sortave[i])) ||
			  ((sortave[ii]>=sortave[j]) && (sortave[jj]<sortave[i]))) nksig[ncombi2]=0;
		    }
		    else {
		      if (((sortave[jj]>sortave[j]) && (sortave[ii]<=sortave[i])) ||
			  ((sortave[jj]>=sortave[j]) && (sortave[ii]<sortave[i]))) nksig[ncombi2]=0;
		    }
		  }
		  ncombi2++;
		}
	    }
	    /* Fisher's LSD test */
	    p_posthoc[3][ncombi]=betai(df/2.0, 0.5, df/(df+(t*t/2.0)));
	    ncombi++;
	  }
	/* output of the results */
	/* headline */
	strcat(out_buf, "\n");
	sprintf(temp, "%23s %10s %10s %10s  %10s \n",
		" ", "Scheffe", "Tukey", "N-Keuls", "Fisher");
	strcat(out_buf, temp);
	ncombi=0;
	for (i=0; i<(anova->nlist-1); i++)
	  for (j=i+1; j<anova->nlist; j++) {
	    if (xqi[i]<xqi[j]) strcpy(signchar, "<");
	    else if (xqi[i]==xqi[j]) strcpy(signchar, "=");
	    else if (xqi[i]>xqi[j]) strcpy(signchar, ">");
	    if (nksig[ncombi]) strcpy(nkchar, " ");
	    else               strcpy(nkchar, "!");
	    sprintf(temp, "%10.10s %1s %10.10s %10.4f %10.4f %10.4f%1.1s %10.4f \n",
		    clabels[anova->list[i]], signchar, clabels[anova->list[j]],
		    p_posthoc[0][ncombi], p_posthoc[1][ncombi],
		    p_posthoc[2][ncombi], nkchar,
		    p_posthoc[3][ncombi]);
	    strcat(out_buf, temp);
	    ncombi++;
	  }
      } /* end if (ndata>=2) */
      for (i=0; i<anova->nlist; i++) delete[]data[i];
      startgroup+=sort.group[k];
      strcat(out_buf, "\n");
    }  /* for k */
    resedit(out_buf, "ANOVA (one-way) for repeated measures");
    /* Free memory and the like */
    delete[]out_buf;
    delete[]temp;
    delete[]data;
    delete[]xqi;
    delete[]s2i;
    delete[]sortave;
    delete[]nksig;
    for (i=0; i<4; i++) delete[]p_posthoc[i];
    delete[]p_posthoc;
    XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
    XFreeCursor(XtDisplay(widget), pfeil);
    XFreeCursor(XtDisplay(widget), uhr);
    XtUnmanageChild(widget);
  }
  else {  /* anova->nlist < 2 */
    showmess(StatData, "one-way-ANOVA, repeated measures",
	     "At least 2 repeated Variables must be selected !");
  }

}

void anova1_rep_list0_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmListCallbackStruct *cbs=(XmListCallbackStruct *) call_data;
  anova_struct         *anova;
  Widget               *list_w;
  String               *clabels;
  char                 *text;
  int                  i, cols, group_n;

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &anova, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  group_n=-1;
  for (i=0; i<cols; i++) {
    if (!strcmp(text, clabels[i])) group_n=i;
  }
  anova->list=(int *) realloc(anova->list, (anova->nlist+1)*sizeof(int));
  anova->list[anova->nlist]=group_n;
  anova->nlist++;
  XtFree(text);
  XmListAddItem(list_w[1], cbs->item, 0);
  XmListDeleteItem(list_w[0], cbs->item);
}

void anova1_rep_list1_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmListCallbackStruct *cbs=(XmListCallbackStruct *) call_data;
  anova_struct         *anova;
  Widget               *list_w;
  String               *clabels;
  char                 *text;
  int                  i, cols, group_n;

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &anova, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  group_n=-1;
  for (i=0; i<cols; i++) {
    if (!strcmp(text, clabels[i])) group_n=i;
  }
  XtFree(text);

  for (i=cbs->item_position-1; i<anova->nlist-1; i++) anova->list[i]=anova->list[i+1];
  anova->nlist--;
  anova->list=(int *) realloc(anova->list, anova->nlist*sizeof(int));

  XmListAddItem(list_w[0], cbs->item, 0);
  XmListDeleteItem(list_w[1], cbs->item);
}


void group_anova1i_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmListCallbackStruct *cbs=(XmListCallbackStruct *) call_data;
  Widget               *list_w, toplevel;
  anova_struct         *anova;
  String               **cells, *clabels;
  char                 *text;
  short                is_new;
  int                  i, j, cols, rows, group_n, elem_n;

  extern void showmess(Widget widget, char *title, char *text);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &anova, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  group_n=-1;
  for (i=0; i<cols; i++) {
    if (!strcmp(text, clabels[i])) group_n=i;
  }
  anova->indep_group_var=group_n;
  XtFree(text);

  if (rows>0) {
    XmListDeleteAllItems(list_w[1]);
    if (strtok(cells[0][group_n]," \t\n\0"))
      XmListAddItem(list_w[1],XmStringCreateLocalized(cells[0][group_n]),0);
    for (i=1; i<rows; i++) {
      is_new=1;
      for (j=0; j<i; j++) {
	if (!strcmp(cells[i][group_n],cells[j][group_n])) is_new=0;
      }
      if (is_new)
	if (strtok(cells[i][group_n]," \t\n\0"))
	  XmListAddItem(list_w[1],XmStringCreateLocalized(cells[i][group_n]),0);
    }
  }
  XtVaGetValues(list_w[1], XmNitemCount, &elem_n, NULL);
  if (elem_n<2) showmess(toplevel, ANOVA1I_GERR1_T, ANOVA1I_GERR1_M);
  else if (elem_n==2) {
    if (anova->ways==1) showmess(toplevel, ANOVA1I_GERR2_T, ANOVA1I_GERR2_M);
    for (i=0; i<elem_n; i++) XmListSelectPos(list_w[1],i+1,False);
  }
  else for (i=0; i<elem_n; i++) XmListSelectPos(list_w[1],i+1,False);
}

void anova1i_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               *list_w;
  Cursor               uhr, pfeil;
  anova_struct         *anova;
  int                  i, j, jj, k, l, ll, cols, rows, select_n, *select_pos, startgroup;
  short                is_enough, rc;
  String               **cells, *clabels, level, level1, level2;
  char                 *out_buf, *temp, *pcells, text[256], signchar[2], nkchar[2];
  XmString             *select_list;
  float                **data;
  float                ssc, sse, xq, f, p, df, t;
  float                *xqi, *s2i, **p_posthoc;
  long                 nxq;
  int                  *sortave, *nksig, ncombi, ncombi2;

  extern void resedit(char *text, char *title);
  extern void avevar(float data[], unsigned long n, float *ave, float *var);
  extern void showmess(Widget widget, char *title, char *text);
  extern void add_line(char *text, int n);
  extern float betai(float a, float b, float x);
  extern double prtrng(double q, double v, double r, short *ifault);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &anova, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];
  if (XmListGetSelectedPos(list_w[1], &select_pos, &select_n)) {
    if (select_n<2)
      showmess(widget, ANOVA1I_GERR3_T, ANOVA1I_GERR3_M);
    else {
      /* now calculate independent ANOVA */
      /* set cursor */
      uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
      pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
      XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
      XFlush(XtDisplay(widget));
      XtVaGetValues(list_w[1], XmNitems, &select_list, NULL);
      /* first allocate data pointer */
      data   =new float*[select_n];
      xqi    =new float[select_n];
      s2i    =new float[select_n];
      sortave=new int[select_n];
      nksig  =new int[select_n*(select_n-1)/2];
      p_posthoc = new float* [4]; // 0: scheffe, 1: tukey, 2: n-keul, 3: fisher;
      for (i=0; i<4; i++) p_posthoc[i]=new float [select_n*(select_n-1)/2];
      /* Headline for all */
      strcpy(out_buf, "ANOVA (one-way) for independent measures \n\n");
      /* loop through sort variables */
      if (sort.ngroup==1) sort.group[0]=rows;
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* first allocate data pointer of pointer */
	for (i=0; i<select_n; i++) data[i]=new float[sort.group[k]+1]; // data[i][0]=n;
	/* Headline for sort group*/
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 75);
	/* loop through dependent vars */
	for (i=0; i<sort.ndep; i++) {
	  if (sort.dep[i]!=anova->indep_group_var) {  // group var. is not a depend. var;
	    /* get data in array */
	    for (j=0; j<select_n; j++) {
	      data[j][0]=0;
	      XmStringGetLtoR(select_list[select_pos[j]-1],XmFONTLIST_DEFAULT_TAG, &level);
	      for (l=startgroup; l<startgroup+sort.group[k]; l++) {
		if (!strcmp(cells[l][anova->indep_group_var], level)) {
		  data[j][(int)data[j][0]+1]=strtod(cells[l][sort.dep[i]], &pcells);
		  // is it numeric ? ;
		  if (data[j][(int)data[j][0]+1]!=0 || strcmp(pcells,cells[l][sort.dep[i]]))
		    data[j][0]++;
		}
	      }
	      XtFree(level);
	    }
	    // calculate ANOVA;
	    is_enough=1;
	    for (j=0; j<select_n; j++)
	      if (data[j][0]<2) is_enough=0; // there must be at least 2 values in each group;
	    if (is_enough) {
	      xq=0; nxq=0; ssc=0; sse=0;
	      for (j=0; j<select_n; j++) {
		avevar(data[j], (unsigned long)data[j][0], &xqi[j], &s2i[j]);
		for (l=0; l<data[j][0]; l++) xq+=data[j][l+1];
		nxq+=(long)data[j][0];
	      }
	      xq/=(float)nxq;
	      for (j=0; j<select_n; j++) {
		ssc+=data[j][0]*(xqi[j]-xq)*(xqi[j]-xq);
		sse+=(data[j][0]-1)*s2i[j];
	      }
	      sprintf(temp, "%10.10s %4s %14s %14s %14s %14s\n",
		      clabels[sort.dep[i]], "df", "sum of squares", "mean squares", "F", "p");
	      strcat(out_buf, temp);
	      f=(ssc/(select_n-1))/(sse/(nxq-select_n));
	      p=betai((float)(nxq-select_n)/2.0, (float)(select_n-1.0)/2.0,
		      (float)(nxq-select_n)/((float)(nxq-select_n)+((float)(select_n-1)*f)));
	      sprintf(temp, "%10s %4d %14.4f %14.4f %14.4f %14.4f \n",
		      "between", select_n-1, ssc, ssc/(select_n-1), f, p);
	      strcat(out_buf, temp);
	      sprintf(temp, "%10s %4d %14.4f %14.4f \n",
		      "error", (nxq-select_n), sse, sse/(nxq-select_n));
	      strcat(out_buf, temp);
	      sprintf(temp, "%10s %4d %14.4f \n",
		      "total", (nxq-1), ssc+sse);
	      strcat(out_buf, temp);
	      /* calculate post-hoc test */
	      /* get sort order by average */
	      for (j=0; j<select_n; j++) {
		sortave[j]=1;
		for (l=0; l<select_n; l++) 
		  if (xqi[l]>xqi[j]) sortave[j]++;
	      }
	      /* set all combis for Newman-Keuls on significant */
	      for (j=0; j<(select_n*(select_n-1)/2); j++) nksig[j]=1;
	      /* loop through levels */
	      ncombi=0;
	      df=(float)(nxq-select_n);
	      for (j=0; j<select_n-1; j++) {    // loop through levels;
		for (l=j+1; l<select_n; l++) {  // second level loop through levels;
		  /* scheffe */
		  f=(xqi[j]-xqi[l])*(xqi[j]-xqi[l])/
		    ((sse/df)*(1.0/data[j][0]+1.0/data[l][0])*((float)select_n-1.0));
		  p_posthoc[0][ncombi]=betai(df/2.0, (float)(select_n-1.0)/2.0,
					     df/(df+((float)(select_n-1.0)*f)));
		  /* Tukey's HSD test */
		  t=(xqi[j]-xqi[l])/sqrt( (sse/df) * 0.5 * (1.0/data[j][0]+1.0/data[l][0]) );
		  p_posthoc[1][ncombi]=1.0-prtrng(fabs(t), df, select_n, &rc);
		  /* Newman-Keuls test */
		  p_posthoc[2][ncombi]=1.0-prtrng(fabs(t), df, abs(sortave[j]-sortave[l])+1, &rc);
		  if (p_posthoc[2][ncombi]>0.05) {
		    ncombi2=0;
		    for (jj=0; jj<select_n-1; jj++) 
		      for (ll=jj+1; ll<select_n; ll++) {
			if (sortave[j]<sortave[l]) {
			  if (sortave[jj]<sortave[ll]) {
			    if (((sortave[jj]>sortave[j]) && (sortave[ll]<=sortave[l])) ||
				((sortave[jj]>=sortave[j]) && (sortave[ll]<sortave[l]))) nksig[ncombi2]=0;
			  }
			  else {
			    if (((sortave[ll]>sortave[j]) && (sortave[jj]<=sortave[l])) ||
				((sortave[ll]>=sortave[j]) && (sortave[jj]<sortave[l]))) nksig[ncombi2]=0;
			  }
			}
			else {
			  if (sortave[jj]<sortave[ll]) {
			    if (((sortave[jj]>sortave[l]) && (sortave[ll]<=sortave[j])) ||
				((sortave[jj]>=sortave[l]) && (sortave[ll]<sortave[j]))) nksig[ncombi2]=0;
			  }
			  else {
			    if (((sortave[ll]>sortave[l]) && (sortave[jj]<=sortave[j])) ||
				((sortave[ll]>=sortave[l]) && (sortave[jj]<sortave[j]))) nksig[ncombi2]=0;
			  }
			}
			ncombi2++;
		      }
		  }
		  /* Fisher's LSD test */
		  p_posthoc[3][ncombi]=betai(df/2.0, 0.5, df/(df+t*t/2.0));
		  ncombi++;
		}
	      }
	      /* output results of post-hoc tests */
	      /* headline */
	      strcat(out_buf, "\n");
	      sprintf(temp, "%23s %10s %10s %10s  %10s \n",
		      " ", "Scheffe", "Tukey", "N-Keuls", "Fisher");
	      strcat(out_buf, temp);
	      ncombi=0;
	      for (j=0; j<select_n-1; j++) {    // loop through levels;
		for (l=j+1; l<select_n; l++) {  // second level loop through levels;
		  XmStringGetLtoR(select_list[select_pos[j]-1],XmFONTLIST_DEFAULT_TAG, &level1);
		  XmStringGetLtoR(select_list[select_pos[l]-1],XmFONTLIST_DEFAULT_TAG, &level2);
		  if (xqi[j]<xqi[l]) strcpy(signchar, "<");
		  else if (xqi[j]==xqi[l]) strcpy(signchar, "=");
		  else if (xqi[j]>xqi[l]) strcpy(signchar, ">");
		  if (nksig[ncombi]) strcpy(nkchar, " ");
		  else               strcpy(nkchar, "!");
		  sprintf(temp, "%10.10s %1s %10.10s %10.4f %10.4f %10.4f%1s %10.4f\n",
			  level1, signchar, level2, p_posthoc[0][ncombi],
			  p_posthoc[1][ncombi], p_posthoc[2][ncombi], nkchar, p_posthoc[3][ncombi]);
		  strcat(out_buf, temp);
		  XtFree(level1); XtFree(level2);
		  ncombi++;
		}
	      }
	    }
	    add_line(out_buf, 75);
	  } // end if ();
	} // end for (i) dependent vars; 
	for (i=0; i<select_n; i++) delete [] data[i];
	startgroup+=sort.group[k];
 	strcat(out_buf, "\n");
      } // end for (k) subgroups;
      delete [] data;
      delete [] xqi;
      delete [] s2i;
      delete [] sortave;
      delete [] nksig;
      for (i=0; i<4; i++) delete[]p_posthoc[i];
      delete[]p_posthoc;
      resedit(out_buf, "ANOVA (one-way) for independent measures");
      XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
      XFreeCursor(XtDisplay(widget), pfeil);
      XFreeCursor(XtDisplay(widget), uhr);
      XtUnmanageChild(widget);
    }
    XtFree((char *)select_pos);
  }
  else showmess(widget, ANOVA1I_GERR3_T, ANOVA1I_GERR3_M);

  delete[]temp;
  delete[]out_buf;
}


/* two-way ANOVA independent-repeated */
void anova2ir_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget         *list_w;
  Cursor         uhr, pfeil;
  anova_struct   *anova;
  short          is_valid;
  int            k, i, j, l;
  int            rows, cols, select_n, *select_pos, startgroup;
  int            df_i, df_i_err, df_r, df_ir, df_ir_err;
  int            n_obs, nxq, *nxqi, *nxqr, nxqir, nxqs;
  float          xq, *xqi, *xqr, xqir, xqs;
  float          ss_i, ss_i_err, ss_r, ss_ir, ss_ir_err, ss_tot;
  float          ***data, f, p;
  String         **cells, *clabels, level;
  XmString       *select_list;
  char           *out_buf, *temp, *pcells;

  extern void  resedit(char *text, char *title);
  extern void  showmess(Widget widget, char *title, char *text);
  extern void  add_line(char *text, int n);
  extern float betai(float a, float b, float x);

  /* get all information */
  list_w=(Widget *)client_data; /* independent list widget */
  XtVaGetValues(widget, XmNuserData, (anova_struct *) &anova, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);

  /* allocate memory */
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];

  /* calculate ANOVA */
  if (XmListGetSelectedPos(list_w[1], &select_pos, &select_n)) {
    /* mindestens zwei repeated variables und zwei independent levels */
    if ((anova->nlist) >=2  && (select_n>=2)) {
      is_valid=1;
      for (j=0; j<anova->nlist; j++) 
	if (anova->indep_group_var==anova->list[j]) is_valid=0;
      if (is_valid) {
	/* set cursor */
	uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
	pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
	XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
	XFlush(XtDisplay(widget));
	XtVaGetValues(list_w[1], XmNitems, &select_list, NULL);
	/* first allocate memory */
	xqi = new float[select_n];
	nxqi = new int[select_n];
	xqr = new float[anova->nlist];
	nxqr = new int[anova->nlist];
	/* Headline for all */
	strcpy(out_buf, "ANOVA (two-way) for independent and repeated measures \n\n");
	/* loop through sort variables */
	if (sort.ngroup==1) sort.group[0]=rows;
	startgroup=0;
	for (k=0; k<sort.ngroup; k++) {
	  /* Headline for sort group*/
	  for (i=0; i<sort.nsort; i++) {
	    sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	    strcat(out_buf, temp);
	  }
	  add_line(out_buf, 71);
	  /* first allocate 3-dim data array (subject,repeated,independent) */
	  data = new float**[sort.group[k]+1]; // data[0][0][j]=n; what a waste of memory;
	  for (i=0; i<(sort.group[k]+1); i++) {
	    data[i] = new float*[anova->nlist];
	    for (j=0; j<anova->nlist; j++) {
	      data[i][j]=new float[select_n];
	    }
	  }
	  for (i=0; i<select_n; i++) data[0][0][i]=0;
	  /* get data in array */
	  for (i=0; i<select_n; i++) {  /* independent levels */
	    XmStringGetLtoR(select_list[select_pos[i]-1],XmFONTLIST_DEFAULT_TAG, &level);
	    for (l=startgroup; l<startgroup+sort.group[k]; l++) { /* subjects */
	      if (!strcmp(cells[l][anova->indep_group_var], level)) {
		is_valid=1;
		for (j=0; j<anova->nlist; j++) {   /* repeated levels */
		  data[(int)data[0][0][i]+1][j][i]=strtod(cells[l][anova->list[j]], &pcells);
		  // is it numeric ? ;
		  if (data[(int)data[0][0][i]+1][j][i]==0 && !strcmp(pcells,cells[l][anova->list[j]]))
		    is_valid=0;
		}
		if (is_valid) data[0][0][i]++;
	      }
	    }
	    XtFree(level);
	  }
	  /* Calculate ANOVA */
	  /* degrees of freedom */
	  /* independent variable */
	  df_i=0;
	  for (i=0; i<select_n; i++) if (data[0][0][i]>0) df_i++;
	  df_i--;
	  /* error of the independent variable */
	  n_obs=0; /* number of observations */
	  for (i=0; i<select_n; i++) n_obs+=(int)data[0][0][i];
	  df_i_err=n_obs-(df_i+1);
	  /* repeated variable */
	  df_r=anova->nlist-1;
	  /* interaction */
	  df_ir=df_i*df_r;
	  /* error term 2 */
	  df_ir_err=df_i_err*df_r;
	  if (df_i>0) {
	    /* Sum of Squares */
	    xq=0; nxq=0;
	    for (i=0; i<select_n; i++)
	      for (j=0; j<anova->nlist; j++)
		for (l=0; l<(int)data[0][0][i]; l++) {
		  xq+=data[l+1][j][i]; nxq++;
		}
	    if (nxq>0) xq/=nxq; else xq=0;
	    for (i=0; i<select_n; i++) {
	      xqi[i]=0; nxqi[i]=0;
	      for (j=0; j<anova->nlist; j++) {
		for (l=0; l<(int)data[0][0][i]; l++) {
		  xqi[i]+=data[l+1][j][i]; nxqi[i]++;
		}
	      }
	      if (nxqi[i]>0) xqi[i]/=nxqi[i]; else xqi[i]=0;
	    }
	    for (j=0; j<anova->nlist; j++) {
	      xqr[j]=0; nxqr[j]=0;
	      for (i=0; i<select_n; i++) {
		for (l=0; l<(int)data[0][0][i]; l++) {
		  xqr[j]+=data[l+1][j][i]; nxqr[j]++;
		}
	      }
	      if (nxqr[j]>0) xqr[j]/=nxqr[j]; else xqr[j]=0;
	    }
	    /* independent variable */
	    ss_i=0;
	    for (i=0; i<select_n; i++) ss_i+=nxqi[i]*(xqi[i]-xq)*(xqi[i]-xq);
	    /* error of the independent variable */
	    ss_i_err=0;
	    for (i=0; i<select_n; i++) {
	      for (l=0; l<(int)data[0][0][i]; l++) {
		xqs=0; nxqs=0;
		for (j=0; j<anova->nlist; j++) {
		  xqs+=data[l+1][j][i]; nxqs++;
		}
		xqs/=nxqs;  // should be safe;
		ss_i_err+=nxqs*(xqs-xqi[i])*(xqs-xqi[i]);
	      }
	    }
	    /* repeated variable */
	    ss_r=0;
	    for (j=0; j<anova->nlist; j++) ss_r+=nxqr[j]*(xqr[j]-xq)*(xqr[j]-xq);
	    /* interaction */
	    ss_ir=0;
	    for (i=0; i<select_n; i++) {
	      for (j=0; j<anova->nlist; j++) {
		xqir=0; nxqir=0;
		for (l=0; l<(int)data[0][0][i]; l++) {
		  xqir+=data[l+1][j][i]; nxqir++;
		}
		if (nxqir>0) xqir/=nxqir; else xqir=0;
		ss_ir+=nxqir*(xqir+xq-xqi[i]-xqr[j])*(xqir+xq-xqi[i]-xqr[j]);
	      }
	    }
	    /* total ss_tot */
	    ss_tot=0;
	    for (i=0; i<select_n; i++) {
	      for (l=0; l<(int)data[0][0][i]; l++) {
		for (j=0; j<anova->nlist; j++) {
		  ss_tot+=(data[l+1][j][i]-xq)*(data[l+1][j][i]-xq);
		}
	      }
	    }
	    /* error term 2 */
	    ss_ir_err=ss_tot - ss_i - ss_i_err - ss_r - ss_ir;
	    /* ANOVA Table Headline */
	    strcat(out_buf, "     Source    df   Sum of Square     Mean Square          F          P \n");
	    sprintf(temp,"    Between %5d %15.5f\n", df_i+df_i_err, ss_i+ss_i_err);
	    strcat(out_buf, temp);
	    f=(ss_i/df_i)/(ss_i_err/df_i_err);
	    p=betai((float)df_i_err/2.0, (float)df_i/2.0, (float)df_i_err/((float)df_i_err+((float)df_i*f)));
	    sprintf(temp, "%11s %5d %15.5f %15.5f %10.3f %10.6f\n",
		    clabels[anova->indep_group_var], df_i, ss_i, ss_i/df_i, f, p);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f\n\n", "error", df_i_err, ss_i_err, ss_i_err/df_i_err);
	    strcat(out_buf, temp);
	    sprintf(temp,"     Within %5d %15.5f\n", df_r+df_ir+df_ir_err, ss_r+ss_ir+ss_ir_err);
	    strcat(out_buf, temp);
	    f=(ss_r/df_r)/(ss_ir_err/df_ir_err);
	    p=betai((float)df_ir_err/2.0, (float)df_r/2.0, (float)df_ir_err/((float)df_ir_err+((float)df_r*f)));
	    sprintf(temp, "%11s %5d %15.5f %15.5f %10.3f %10.6f\n", "repeated",
		    df_r, ss_r, ss_r/df_r, f, p);
	    strcat(out_buf, temp);
	    f=(ss_ir/df_ir)/(ss_ir_err/df_ir_err);
	    p=betai((float)df_ir_err/2.0, (float)df_ir/2.0, (float)df_ir_err/((float)df_ir_err+((float)df_ir*f)));
	    sprintf(temp, "%11s %5d %15.5f %15.5f %10.3f %10.6f\n", "interaction",
		    df_ir, ss_ir, ss_ir/df_ir, f, p);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f\n", "error", df_ir_err, ss_ir_err, ss_ir_err/df_ir_err);
	    strcat(out_buf, temp);
	    // I don't show the totals;
	    // sprintf(temp, "%11s %5d %15.5f\n", "total", n_obs*anova->nlist-1, ss_tot);
	    // strcat(out_buf, temp);
	  } /* endif: df_i>0 */

	  /* free memory */
	  for (i=0; i<(sort.group[k]+1); i++) {
	    for (j=0; j<anova->nlist; j++)
	      delete [] data[i][j];
	    delete [] data[i];
	  }
	  delete [] data;
	  startgroup+=sort.group[k];
	  strcat(out_buf, "\n");
	} /* endfor k */
      
	/* Alles erledigt, jetzt aufrumen */
	resedit(out_buf, "ANOVA (two-way) for independent and repeated measures");
	delete [] xqi; delete [] xqr;
	delete [] nxqi; delete [] nxqr;
	XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
	XFreeCursor(XtDisplay(widget), pfeil);
	XFreeCursor(XtDisplay(widget), uhr);
	XtUnmanageChild(widget);
      }
      else showmess(widget, ANOVA2IR_GERR2_T, ANOVA2IR_GERR2_M);
    }
    else showmess(widget, ANOVA2IR_GERR1_T, ANOVA2IR_GERR1_M);
  }

  /* Speicher freigeben */
  delete[]temp;
  delete[]out_buf;

}


/* independent - independent ANOVA */
void anova2ii_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget         *list_w;
  Cursor         uhr, pfeil;
  anova_struct   *anova;
  char           *out_buf, *temp;
  int            i, k, m, m1, m2, n, startgroup, ndata;
  int            rows, cols, pos_count, *pos_list;
  int            nlevel1, *level_pos1, nlevel2, *level_pos2;  
  int            indep_group1, indep_group2;
  float          **datai;
  String         **cells, *clabels;
  XmString       *ind_items, *levels1, *levels2;
  char           *text, *text1, *text2, *pcells;
  short          is_enough, is_valid1, is_valid2;
  int            df_1, df_2, df_t, df_e, df_i;
  float          xq, *xqi;
  float          ss_1_hto, ss_2_hto, ss_1_hti, ss_2_hti, ss_1_I;
  float          ss_1, ss_2, ss_i, ss_e, ss_t;
  float          f, p_1, p_2, p_i;
  float          *y, result;
  int            *a, *b, **sma, **smb, **smab, **xe, **xr;

  extern void  showmess(Widget widget, char *title, char *text);
  extern void  resedit(char *text, char *title);
  extern void  add_line(char *text, int n);
  extern float betai(float a, float b, float x);
  void ss_proc(float* y, int** xe, int** xr, int n, int xen, int xrn, float *result);

  /* get all information */
  list_w=(Widget *)client_data; /* independent list widget (array of 4 lists) */
  XtVaGetValues(widget, XmNuserData, &anova, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);

  /* get the two independent group numbers */
  /* first ind. group number */
  XtVaGetValues(list_w[0], XmNitems, &ind_items, NULL);
  XmListGetSelectedPos(list_w[0], &pos_list, &pos_count);
  if (pos_count>0) {
    XmStringGetLtoR(ind_items[pos_list[0]-1], XmFONTLIST_DEFAULT_TAG, &text);
    indep_group1=-1;
    for (i=0; i<cols; i++) {
      if (!strcmp(text, clabels[i])) indep_group1=i;
    }
    XtFree(text);
  }
  delete [] pos_list;
  /* second ind. group number */
  XtVaGetValues(list_w[2], XmNitems, &ind_items, NULL);
  XmListGetSelectedPos(list_w[2], &pos_list, &pos_count);
  if (pos_count>0) {
    XmStringGetLtoR(ind_items[pos_list[0]-1], XmFONTLIST_DEFAULT_TAG, &text);
    indep_group2=-1;
    for (i=0; i<cols; i++) {
      if (!strcmp(text, clabels[i])) indep_group2=i;
    }
    XtFree(text);
  }
  delete [] pos_list;

  /* allocate memory */
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];

  /* calculate ANOVA */
  if (indep_group1 != indep_group2) {
    XmListGetSelectedPos(list_w[1], &level_pos1, &nlevel1);
    XmListGetSelectedPos(list_w[3], &level_pos2, &nlevel2);
    XtVaGetValues(list_w[1], XmNitems, &levels1, NULL);
    XtVaGetValues(list_w[3], XmNitems, &levels2, NULL);
    /* mindestens zwei mal zwei independent levels */
    if ((nlevel1>=2)  && (nlevel2>=2)) {
      /* set cursor */
      uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
      pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
      XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
      XFlush(XtDisplay(widget));

      /* first allocate data arrays */
      datai = new float* [nlevel1*nlevel2];
      for (i=0; i<(nlevel1*nlevel2); i++) {
	datai[i]=new float[1];
	datai[i][0]=0; // number of data points for this level;
      }
      xqi = new float [nlevel1*nlevel2];
      a=new int[1];
      b=new int[1];
      y=new float[1];
      sma =new int*[rows];
      smb =new int*[rows];
      smab=new int*[rows];
      xr  =new int*[rows];
      for (n=0; n<rows; n++) {
	sma[n]  = new int[1];
	smb[n]  = new int[1];
	smab[n] = new int[1];
	xr[n]   = new int[1];
      }
      /* Headline for all */
      strcpy(out_buf, "ANOVA (two-way) for independent measures\n");
      switch(anova->ssq_type) {
      case 1:
	strcpy(temp, "(Type I (sequential) for unbalanced designes)\n\n");
	strcat(out_buf, temp);
	break;
      case 2:
	strcpy(temp, "(Type II (HTO) for unbalanced designes)\n\n");
	strcat(out_buf, temp);
	break;
      case 3:
	strcpy(temp, "(Type III (HTI) for unbalanced designes)\n\n");
	strcat(out_buf, temp);
	break;
      }
      /* loop through sort variables */
      if (sort.ngroup==1) sort.group[0]=rows;
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* Headline for sort group*/
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 72);
	/* allocate memory */
	for (m=0; m<(nlevel1*nlevel2); m++)
	  datai[m]=(float *) realloc(datai[m], (sort.group[k]+1)*sizeof(float));
	a=(int *)realloc(a, sort.group[k]*sizeof(int));
	b=(int *)realloc(b, sort.group[k]*sizeof(int));
	y=(float *)realloc(y, sort.group[k]*sizeof(float));

	/* loop through dependent vars */
	for (i=0; i<sort.ndep; i++) {
	  /* construct a, b, y */
	  ndata=0;
	  for (n=startgroup; n<startgroup+sort.group[k]; n++) {
	    is_valid1=0; is_valid2=0;
	    y[ndata]=strtod(cells[n][sort.dep[i]], &pcells);
	    // is it numeric ? ;
	    if (y[ndata]!=0 || strcmp(pcells,cells[n][sort.dep[i]])) {
	      for (m=0; m<nlevel1; m++) {
		XmStringGetLtoR(levels1[level_pos1[m]-1], XmFONTLIST_DEFAULT_TAG, &text);
		if (!strcmp(cells[n][indep_group1], text)) {
		  a[ndata]=m+1;
		  is_valid1=1;
		}
	      }
	      for (m=0; m<nlevel2; m++) {
		XmStringGetLtoR(levels2[level_pos2[m]-1], XmFONTLIST_DEFAULT_TAG, &text);
		if (!strcmp(cells[n][indep_group2], text)) {
		  b[ndata]=m+1;
		  is_valid2=1;
		}
	      }
	      if (is_valid1 && is_valid2) ndata++;
	    }
	  }
	  /* data for interaction */
	  df_t=0;
	  for (m1=0; m1<nlevel1; m1++) {
	    for (m2=0; m2<nlevel2; m2++) {
	      ndata=0;
	      for (n=startgroup; n<startgroup+sort.group[k]; n++) {
		XmStringGetLtoR(levels1[level_pos1[m1]-1], XmFONTLIST_DEFAULT_TAG, &text1);
		XmStringGetLtoR(levels2[level_pos2[m2]-1], XmFONTLIST_DEFAULT_TAG, &text2);
		if ((!strcmp(cells[n][indep_group1],text1)) && (!strcmp(cells[n][indep_group2],text2))) {
		  datai[m1*nlevel2+m2][ndata+1]=strtod(cells[n][sort.dep[i]], &pcells);
		  // is it numeric ? ;
		  if (datai[m1*nlevel2+m2][ndata+1]!=0 || strcmp(pcells,cells[n][sort.dep[i]])) ndata++;
		}
		XtFree(text1);
		XtFree(text2);
	      }
	      datai[m1*nlevel2+m2][0]=ndata;
	      df_t+=ndata;
	    }
	  }
	  df_t--;
	  /* Calculate ANOVA */
	  is_enough=1;
	  for (m1=0; m1<nlevel1; m1++) {
	    for (m2=0; m2<nlevel2; m2++) {
	      if (datai[m1*nlevel2+m2][0]<2) is_enough=0;
	    }
	  }
	  if (is_enough) {
	    /* Degrees of freedom */
	    df_1=nlevel1-1;
	    df_2=nlevel2-1;
	    df_i=df_1*df_2;
	    df_e=df_t-df_1-df_2-df_i;
	    /* calculate means */
	    xq=0;
	    for (m1=0; m1<nlevel1; m1++)
	      for (m2=0; m2<nlevel2; m2++) {
		xqi[m1*nlevel2+m2]=0;
		for (n=0; n<(int)datai[m1*nlevel2+m2][0]; n++) {
		  xq+=datai[m1*nlevel2+m2][n+1];
		  xqi[m1*nlevel2+m2]+=datai[m1*nlevel2+m2][n+1];
		}
		xqi[m1*nlevel2+m2]/=datai[m1*nlevel2+m2][0];
	      }
	    xq/=(df_t+1);
	    /* construct submatrices */
	    /* fist allocate memory */
	    for (n=0; n<sort.group[k]; n++) {
	      sma[n]  = (int *)realloc(sma[n], df_1*sizeof(int));
	      smb[n]  = (int *)realloc(smb[n], df_2*sizeof(int));
	      smab[n] = (int *)realloc(smab[n], df_i*sizeof(int));
	    }
	    /* submatrix a */
	    for (m=1; m<nlevel1; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (a[n]==m) sma[n][m-1]=1;
		else if (a[n]==nlevel1) sma[n][m-1]=-1;
		else sma[n][m-1]=0;
	      }
	    }
	    /* submatrix b */
	    for (m=1; m<nlevel2; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (b[n]==m) smb[n][m-1]=1;
		else if (b[n]==nlevel2) smb[n][m-1]=-1;
		else smb[n][m-1]=0;
	      }
	    }
	    /* submatrix a*b */
	    for (m1=0; m1<(nlevel1-1); m1++) {
	      for (m2=0; m2<(nlevel2-1); m2++) {
		for (n=0; n<(df_t+1); n++) {
		  smab[n][m1*nlevel2+m2]=sma[n][m1]*smb[n][m2];
		}
	      }
	    }
	    /* construct XE and XR for factor 1 HTO */
	    xe=sma;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1+df_2)*sizeof(int));
	    }
	    for (m=-1; m<df_2; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (m==-1) xr[n][m+1]=1;   // factor mu;
		else xr[n][m+1]=smb[n][m]; // matrix b
	      }
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_1, df_2+1, &result);
	    ss_1_hto=result;
	    /* construct XE and XR for factor 2 HTO */
	    xe=smb;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1+df_1)*sizeof(int));
	    }
	    for (m=-1; m<df_1; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (m==-1) xr[n][m+1]=1;   // factor mu;
		else xr[n][m+1]=sma[n][m];
	      }
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_2, df_1+1, &result);
	    ss_2_hto=result;
	    /* construct XE and XR for interaction HTO */
	    xe=smab;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1+df_1+df_2)*sizeof(int));
	    }
	    for (m=-1; m<df_1+df_2; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (m==-1) xr[n][m+1]=1;   // factor mu;
		else if (m<df_1) xr[n][m+1]=sma[n][m];
		else xr[n][m+1]=smb[n][m-df_1];
	      }
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_i, df_1+df_2+1, &result);
	    ss_i=result;
	    /* construct XE and XR for factor 1 HTI */
	    xe=sma;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1+df_2+df_i)*sizeof(int));
	    }
	    for (m=-1; m<df_2+df_i; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (m==-1) xr[n][m+1]=1;   // factor mu;
		else if (m<df_2) xr[n][m+1]=smb[n][m];
		else xr[n][m+1]=smab[n][m-df_2];
	      }
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_1, 1+df_2+df_i, &result);
	    ss_1_hti=result;
	    /* construct XE and XR for factor 2 HTI */
	    xe=smb;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1+df_1+df_i)*sizeof(int));
	    }
	    for (m=-1; m<df_1+df_i; m++) {
	      for (n=0; n<(df_t+1); n++) {
		if (m==-1) xr[n][m+1]=1;   // factor mu;
		else if (m<df_1) xr[n][m+1]=sma[n][m];
		else xr[n][m+1]=smab[n][m-df_1];
	      }
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_2, 1+df_1+df_i, &result);
	    ss_2_hti=result;
	    /* construct XE and XR for factor 1 TYPE I */
	    xe=sma;
	    for (n=0; n<(df_t+1); n++) {
	      xr[n]=(int *)realloc(xr[n], (1)*sizeof(int));
	    }
	    for (n=0; n<(df_t+1); n++) {
	      xr[n][0]=1;   // factor mu;
	    }
	    ss_proc(y, xe, xr, (df_t+1), df_1, 1, &result);
	    ss_1_I=result;
	    /* assign sum of squares */
	    switch(anova->ssq_type) {
	    case 1:
	      ss_1=ss_1_I;
	      ss_2=ss_2_hto;
	      break;
	    case 2:
	      ss_1=ss_1_hto;
	      ss_2=ss_2_hto;
	      break;
	    case 3:
	      ss_1=ss_1_hti;
	      ss_2=ss_2_hti;
	      break;
	    }
	    /* calculate ss_e and ss_t */
	    ss_e=0;
	    for (m1=0; m1<nlevel1; m1++)
	      for (m2=0; m2<nlevel2; m2++)
		for (n=0; n<datai[m1*nlevel2+m2][0]; n++)
		  ss_e+=(datai[m1*nlevel2+m2][n+1]-xqi[m1*nlevel2+m2])*
		        (datai[m1*nlevel2+m2][n+1]-xqi[m1*nlevel2+m2]);
	    ss_t=0;
	    for (m1=0; m1<nlevel1; m1++)
	      for (m2=0; m2<nlevel2; m2++)
		for (n=0; n<datai[m1*nlevel2+m2][0]; n++)
		  ss_t+=(datai[m1*nlevel2+m2][n+1]-xq)*(datai[m1*nlevel2+m2][n+1]-xq);
	    /* calculate p-values */
	    f=(ss_1/df_1)/(ss_e/df_e);
	    p_1=betai((float)df_e/2.0, (float)df_1/2.0, (float)df_e/((float)df_e+((float)df_1*f)));
	    f=(ss_2/df_2)/(ss_e/df_e);
	    p_2=betai((float)df_e/2.0, (float)df_2/2.0, (float)df_e/((float)df_e+((float)df_2*f)));
	    f=(ss_i/df_i)/(ss_e/df_e);
	    p_i=betai((float)df_e/2.0, (float)df_i/2.0, (float)df_e/((float)df_e+((float)df_i*f)));

	    /* ANOVA Table */
	    sprintf(temp, "%11s %5s %15s %15s %11s %10s\n",
		    clabels[sort.dep[i]], "df", "sum of squares", "mean squares", "F", "P");
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f %11.6f %10.6f\n",
		    clabels[indep_group1], df_1, ss_1, ss_1/df_1, (ss_1/df_1)/(ss_e/df_e), p_1);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f %11.6f %10.6f\n",
		    clabels[indep_group2], df_2, ss_2, ss_2/df_2, (ss_2/df_2)/(ss_e/df_e), p_2);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f %11.6f %10.6f\n",
		    "Interaction", df_i, ss_i, ss_i/df_i, (ss_i/df_i)/(ss_e/df_e), p_i);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f %15.5f\n",
		    "Error", df_e, ss_e, ss_e/df_e);
	    strcat(out_buf, temp);
	    sprintf(temp, "%11s %5d %15.5f\n\n",
		    "Total", df_t, ss_t);
	    strcat(out_buf, temp);
	    /* free some memory */
	  } /* endif (is_enough) */
	} /* endfor i (dep. var) */
	startgroup+=sort.group[k];
	strcat(out_buf, "\n");
      } /* endfor k (subgroups) */
      for (n=0; n<rows; n++) {
	delete[]sma[n];
	delete[]smb[n];
	delete[]smab[n];
	delete[]xr[n];
      }
      delete[]sma; delete[]smb; delete[]smab; delete[]xr;
      delete[]a; delete[]b; delete[]y;
      /* Alles erledigt, jetzt aufrumen */
      resedit(out_buf, "ANOVA (two-way) for independent measures");
      XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
      XFreeCursor(XtDisplay(widget), pfeil);
      XFreeCursor(XtDisplay(widget), uhr);
      XtUnmanageChild(widget);
      /* free data arrays */
      for (m1=0; m1<nlevel1; m1++)
	for (m2=0; m2<nlevel2; m2++) {
	  delete[]datai[m1*nlevel2+m2];
	}
      delete[]datai;
      delete[]xqi;
    }
    else showmess(widget, ANOVA2II_ERR2_T, ANOVA2II_ERR2_M);
  }
  else showmess(widget, ANOVA2II_ERR1_T, ANOVA2II_ERR1_M);
   

  /* Speicher freigeben */
  delete[]temp;
  delete[]out_buf;
}

void ss_proc(float* y, int** xe, int** xr, int n, int xen, int xrn, float *result) {
  float **matrix1, **matrix2, **txr, **fxr, **fxe, **th, **h, **data, **xhelp;
  int   i, j;
  int   *indx;
  float d, *col;

  void mat_multi(float** m1, float** m2, int r1, int c1, int r2, int c2, float** r);
  extern void ludcmp(float **a, int n, int *indx, float *d);
  extern void lubksb(float **a, int n, int *indx, float b[]);

  /* allocate memory */
  /* first two very large matrices */
  matrix1=new float*[xen+xrn+n];
  for (i=0; i<xen+xrn+n; i++) {
    matrix1[i]=new float [xen+xrn+n];
  }
  matrix2=new float*[xen+xrn+n];
  for (i=0; i<xen+xrn+n; i++) {
    matrix2[i]=new float [xen+xrn+n];
  }
  txr=new float* [xrn];
  for (i=0; i<xrn; i++) txr[i]=new float[n];
  th =new float* [xen];
  for (i=0; i<xen; i++) th[i]=new float[n];
  fxr=new float* [n];
  for (i=0; i<n; i++) fxr[i]=new float[xrn];
  fxe=new float* [n];
  h=  new float* [n];
  data=new float*[n];
  for (i=0; i<n; i++) {
    fxe[i]=new float[xen];
    h[i]  =new float[xen];
    data[i]=new float[1];
    data[i][0]=y[i];
  }
  indx=new int[1];
  col=new float[1];
  
  /* transpose xr and convert xr to float */
  for (i=0; i<n; i++) {
    for (j=0; j<xrn; j++) {
      txr[j][i]=(float)xr[i][j];
      fxr[i][j]=(float)xr[i][j];
    }
    for (j=0; j<xen; j++) {
      fxe[i][j]=(float)xe[i][j];
    }
  }

  mat_multi(txr, fxr, xrn, n, n, xrn, matrix1);  // generates a xrn x xrn matrix;

  /* invert result of the former */
  indx=(int *)realloc(indx, xrn*sizeof(int));
  col=(float *)realloc(col, xrn*sizeof(float));
  xhelp=submatrix(matrix1, 0, xrn-1, 0, xrn-1, 1, 1);
  ludcmp(xhelp, xrn, indx-1, &d);
  for (j=0; j<xrn; j++) {
    for (i=0; i<xrn; i++) col[i]=0.0;
    col[j]=1.0;
    lubksb(xhelp, xrn, indx-1, col-1);
    for (i=0; i<xrn; i++) matrix2[i][j]=col[i];
  }

  mat_multi(fxr, matrix2, n, xrn, xrn, xrn, matrix1); // generates a n x xrn matrix;
  mat_multi(matrix1, txr, n, xrn, xrn, n, matrix2);   // generates a n x n matrix;
  mat_multi(matrix2, fxe, n, n, n, xen, matrix1);     // generates a n x xen matrix;
  /* subtract XE - MATRIX1 */
  for (i=0; i<n; i++)
    for (j=0; j<xen; j++)
      h[i][j]=fxe[i][j]-matrix1[i][j];          // H, a (n x xen) matrix;

  /* calculate pm */
  /* transpose H  */
  for (i=0; i<n; i++) {
    for (j=0; j<xen; j++) {
      th[j][i]=h[i][j];
    }
  }
  mat_multi(th, h, xen, n, n, xen, matrix1);   // generate a xen x xen matrix;
  /* invert result of the former */
  indx=(int *)realloc(indx, xen*sizeof(int));
  col=(float *)realloc(col, xen*sizeof(float));
  xhelp=submatrix(matrix1, 0, xen-1, 0, xen-1, 1, 1);
  ludcmp(xhelp, xen, indx-1, &d);
  for (j=0; j<xen; j++) {
    for (i=0; i<xen; i++) col[i]=0.0;
    col[j]=1.0;
    lubksb(xhelp, xen, indx-1, col-1);
    for (i=0; i<xen; i++) matrix2[i][j]=col[i];
  }
  mat_multi(h, matrix2, n, xen, xen, xen, matrix1);  // generate a n x xen matrix;
  mat_multi(matrix1, th, n, xen, xen, n, matrix2);   // generate a n x n matrix;
  /* generate yp */
  mat_multi(matrix2, data, n, n, n, 1, matrix1);        // generate a n x 1 matrix;
  /* generate result */
  *result=0;
  for (i=0; i<n; i++) {
    *result+=matrix1[i][0]*matrix1[i][0];
  }

  /* free memory */
  for (i=0; i<n; i++) {
    delete[]matrix1[i];
    delete[]matrix2[i];
    delete[]fxr[i];
    delete[]fxe[i];
    delete[]h[i];
    delete[]data[i];
  }
  delete[]matrix1; delete[]matrix2;
  delete[]fxr; delete[]fxe; delete[]h; delete[]data;
  for (i=0; i<xrn; i++) delete[]txr[i];
  for (i=0; i<xen; i++) delete[]th[i];
  delete[]txr;
  delete[]th;
  delete[]indx;
  delete[]col;
}

void mat_multi(float** m1, float** m2, int r1, int c1, int r2, int c2, float** r) {
  int i, j, k;

  for (i=0; i<r1; i++) { // rows m1;
    for (j=0; j<c2; j++) { // cols m2;
      r[i][j]=0;
      for (k=0; k<c1; k++) r[i][j]+=m1[i][k]*m2[k][j];
    }
  }
}
